using System;
using System.Collections;
using System.Xml;
using System.Xml.XPath;

namespace NeoCoreFAQ001
{
	/// <summary>
	/// FAQ̃wb_ꗗ\IuWFNg
	/// </summary>
	public class XmlHeaderList : System.Xml.XmlDocument
	{
		private int count;
		private ArrayList list;

		/// <summary>
		/// XPathA\[gL[^ăwb_ꗗ\IuWFNg𐶐܂
		/// </summary>
		/// <param name="queryXml">wb_ꗗXPath</param>
		/// <param name="sort_key">̃L[ƂȂ</param>
		public XmlHeaderList(string queryXml, string sort_key) 
		{
			this.LoadXml(queryXml);
			this.AddSort(sort_key);
		}

		/// <summary>
		/// wb_̔z
		/// </summary>
		public ArrayList List
		{
			get 
			{
				return list;
			}
			set {}
		}

		/// <summary>
		/// wb_񌏐
		/// </summary>
		public int Count
		{
			get 
			{
				return count;
			}
			set {}
		}

		/// <summary>
		/// \[gL[^ăwb_̔z擾܂
		/// </summary>
		/// <param name="sort_key">̃L[ƂȂ</param>
		public void AddSort(string sort_key)
		{
			list = new ArrayList();

			XPathNavigator nav = this.CreateNavigator();
			XPathExpression expr;
			if ( sort_key != "" ) 
			{
				expr = nav.Compile("/Query-Results/header[" + sort_key + "]");
				expr.AddSort(sort_key, XmlSortOrder.Descending, XmlCaseOrder.None, "", XmlDataType.Text);
			}
			else 
			{
				expr = nav.Compile("/Query-Results/header");
			}
			XPathNodeIterator iterator = nav.Select(expr);
			for (int i=0; iterator.MoveNext(); i++) 
			{
				XmlNodeList nodeList = ((IHasXmlNode)iterator.Current).GetNode().ChildNodes;
				Hashtable h = new Hashtable();
				for ( int j=0; j<nodeList.Count; j++ ) 
				{
					h.Add(nodeList[j].Name, nodeList[j].InnerText);
				}
				list.Add(h);
			}
			this.count = list.Count;
		}


	}
}
