using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Xml.XPath;
using NEOCOREXMSLib;

namespace NeoCoreFAQ001
{
	/// <summary>
	/// NeoCore FAQ gbvy[W
	/// </summary>
	public class index : System.Web.UI.Page
	{
		protected NeoCore.PanelControl.XMSPanelControl Questions;
		protected System.Web.UI.WebControls.Label LabelMessage;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Table Table1;
		protected System.Web.UI.WebControls.TextBox s;
		protected System.Web.UI.WebControls.LinkButton SearchLink;
		protected NeoCore.PanelControl.XMSPanelControl header;
		protected NeoCore.PanelControl.XMSPanelControl detail;
		protected NeoCore.PanelControl.XMSPanelControl question;
		protected NeoCore.PanelControl.XMSPanelControl from;
		protected System.Web.UI.WebControls.Label LabelSubject;
		protected NeoCore.PanelControl.XMSPanelTextBox subject;
		protected System.Web.UI.WebControls.Label LabelName;
		protected System.Web.UI.WebControls.Label LabelCompany;
		protected System.Web.UI.WebControls.Label LabelEMial;
		protected System.Web.UI.WebControls.Label LabelDescription;
		protected NeoCore.PanelControl.XMSPanelTextBox name;
		protected NeoCore.PanelControl.XMSPanelTextBox company;
		protected NeoCore.PanelControl.XMSPanelTextBox email;
		protected NeoCore.PanelControl.XMSPanelTextBox description;
		protected System.Web.UI.WebControls.Button ButtonSubmit;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		private NeoCoreAPI neo;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if ( Request.HttpMethod == "GET" ) 
			{
				ListView();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
			neo = (NeoCoreAPI)Session["NeoCoreAPI"];
		}
		
		/// <summary>
		/// Designer T|[gɕKvȃ\bhłBR[h GfB^
		/// ̃\bh̃RecύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.ButtonSubmit.Click += new System.EventHandler(this.Button1_Click);
			this.SearchLink.Click += new System.EventHandler(this.SearchLink_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Button1_Click(object sender, System.EventArgs e)
		{
			XmlQuestions q = new XmlQuestions();
			q.LoadXml(Questions.ToXML());
			q.storeXml(neo);

			ListView();
		}

		private void SearchLink_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("search_result.aspx?s=" + Request["s"]);
		}

		private void ListView() 
		{
			XmlHeaderList doc = new XmlHeaderList(neo.queryXML("/ND/Questions/header[count(secret)=0]"), "last-updated");
			TableRow titleRow = new TableRow();
			TableCell[] titleCells = new TableCell[3];
			titleCells[0] = new TableCell();
			titleCells[1] = new TableCell();
			titleCells[2] = new TableCell();
			titleCells[0].Text = "<b></b>";
			titleCells[1].Text = "<b>ŏIXV</b>";
			titleCells[2].Text = "<b></b>";
			titleRow.Cells.AddRange(titleCells);
			this.Table1.Rows.Add(titleRow);
			string col;
			for (int i=0; i<doc.Count; i++)
			{
				col = "white";
				if ( (i%2) == 0 ) col = "#EEEEFF";
				this.Table1.Rows.Add(this.makeRow((Hashtable)doc.List[i], col));
			}
		}

		private TableRow makeRow(Hashtable ht, string col) 
		{
			HyperLink h = new HyperLink();
			h.Text = ht["subject"].ToString();
			h.NavigateUrl = "question_detail.aspx?id=" + ht["id"].ToString();

			TableRow tRow = new TableRow();
			TableCell[] tCells = new TableCell[3];
			tCells[0] = new TableCell();
			tCells[1] = new TableCell();
			tCells[2] = new TableCell();
			tCells[0].Controls.Add(h);
			tCells[1].Text = ht["last-updated"].ToString();
			tCells[2].Text = ht["status"].ToString();
			tRow.Cells.AddRange(tCells);

			tRow.Attributes.Add("bgcolor", col);

			return tRow;
		}
	}
}
